org.eclipse.jetty.servlets

## Class CGI

- java.lang.Object
- - javax.servlet.GenericServlet
  - - javax.servlet.http.HttpServlet
    - - org.eclipse.jetty.servlets.CGI

All Implemented Interfaces:
  Serializable, javax.servlet.Servlet, javax.servlet.ServletConfig

    public class CGI
    extends javax.servlet.http.HttpServlet

CGI Servlet.

The cgi bin directory can be set with the "cgibinResourceBase" init parameter or it will default to the resource base of the context. If the "cgibinResourceBaseIsRelative" init parameter is set the resource base is relative to the webapp. For example "WEB-INF/cgi" would work.
Not that this only works for extracted war files as "jar cf" will not reserve the execute permissions on the cgi files.

The "commandPrefix" init parameter may be used to set a prefix to all commands passed to exec. This can be used on systems that need assistance to execute a particular file type. For example on windows this can be set to "perl" so that perl scripts are executed.

The "Path" init param is passed to the exec environment as PATH. Note: Must be run unpacked somewhere in the filesystem.

Any initParameter that starts with ENV_ is used to set an environment variable with the name stripped of the leading ENV_ and using the init parameter value.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`CGI()`

### Method Summary

Methods
`void` `init()`
`void` `service(javax.servlet.http.HttpServletRequest req, javax.servlet.http.HttpServletResponse res)`

### Methods inherited from class javax.servlet.http.HttpServlet

`doDelete, doGet, doHead, doOptions, doPost, doPut, doTrace, getLastModified, service`

### Methods inherited from class javax.servlet.GenericServlet

`destroy, getInitParameter, getInitParameterNames, getServletConfig, getServletContext, getServletInfo, getServletName, init, log, log`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CGI

    public CGI()

### Method Detail

#### init

    public void init()
              throws javax.servlet.ServletException

Overrides:
  `init` in class `javax.servlet.GenericServlet`
Throws:
  `javax.servlet.ServletException`

#### service

    public void service(javax.servlet.http.HttpServletRequest req,
               javax.servlet.http.HttpServletResponse res)
                 throws javax.servlet.ServletException,
                        IOException

Overrides:
  `service` in class `javax.servlet.http.HttpServlet`
Throws:
  `javax.servlet.ServletException`
  `IOException`